function end_date() {
    date -ud "$1 00:00" +"%Y%m%d%H%M%S"
}
function one_day_ago() {
    date -ud "$1 00:00 1 day ago" +"%Y%m%d%H%M%S"
}
function one_week_ago() {
    date -ud "$1 00:00 1 week ago" +"%Y%m%d%H%M%S"
}

FILE_LIST=""

END_DATE=`end_date $1`
DAY_DATE=`one_day_ago $1`
WEEK_DATE=`one_week_ago $1`
for DATE in $DAY_DATE $WEEK_DATE; do
    for DATA in cpu vsize; do

        echo loop date=$DATE data=$DATA

        OUTFILE=${DATA}_${END_DATE:0:8}_${DATE:0:8}.png
        python make_plot.py $OUTFILE $DATE $END_DATE `cat ${DATA}_args.txt`

        echo Generated $OUTFILE

        FILE_LIST="$FILE_LIST $OUTFILE"
    done
done

function nice_date() {
    echo ${1:0:4}-${1:4:2}-${1:6:2}
}

NICE_END=`nice_date $END_DATE`
NICE_DAY=`nice_date $DAY_DATE`
NICE_WEEK=`nice_date $WEEK_DATE`

cat > ${END_DATE}.html <<HTML_FILE_END
<html>
    <head>
        <title>Filesync Graphs (Averages per server process)</title>
    </head>
    <body>
        <h1>Filesync Graphs (Averages per server process)</h1>
        [<a href=".">older graphs</a>]
        <p>
        <h2>Single Day ($NICE_DAY)</h2>
        <img src="cpu_${END_DATE:0:8}_${DAY_DATE:0:8}.png"/>
        <img src="vsize_${END_DATE:0:8}_${DAY_DATE:0:8}.png"/>
        <p>
        <h2>Week ($NICE_WEEK - $NICE_END)</h2>
        <img src="cpu_${END_DATE:0:8}_${WEEK_DATE:0:8}.png"/>
        <img src="vsize_${END_DATE:0:8}_${WEEK_DATE:0:8}.png"/>
    </body>
</html>
HTML_FILE_END

cat > index.html <<INDEX_FILE_END
<html>
    <head>
        <meta http-equiv="Refresh" content="0;url=filesync/${END_DATE}.html"/>
    </head>
    <body>Redirecting...</body>
</html>
INDEX_FILE_END

FILELIST="${END_DATE}.html $FILE_LIST"
echo $FILELIST

scp `echo $FILELIST` chinstrap.canonical.com:public_html/filesync
scp index.html chinstrap.canonical.com:public_html
