import cookielib
import getpass
import os
import stat
import sys

import mechanize

class Fetcher(object):
    # url = 'https://graphite.ubunet.canonical.com/render/?target=statsd.production.*.resources.sys.cpu.*.%7Buser,system,iowait,idle%7D.value&format=raw&from=-1days'
    # cookie_file = "cookies.dat"

    def __init__(self):
        self.browser = mechanize.Browser()

        self.browser.set_handle_equiv(True)
        self.browser.set_handle_gzip(True)
        self.browser.set_handle_redirect(True)
        self.browser.set_handle_referer(True)
        self.browser.set_handle_robots(False)
        self.browser.set_handle_refresh(mechanize._http.HTTPRefreshProcessor(),
                                        max_time=1)

    def fetch(self, url, cookie_file):
        cookie_jar = cookielib.LWPCookieJar(cookie_file)
        if os.path.exists(cookie_file):
            cookie_jar.load(ignore_discard=True)
        self.browser.set_cookiejar(cookie_jar)

        self.browser.open(url)
        if self.browser.geturl() == \
                          "https://graphite.ubunet.canonical.com/openid/+login":
        # if self.browser.response().info()['Content-Type'] != 'text/plain':
            self.auth(url)
        cookie_jar.save(ignore_discard=True)
        os.chmod(cookie_file, stat.S_IRUSR | stat.S_IWUSR)

        return self.browser.response()

    def auth(self, url):
        br = self.browser
        url = br.geturl()
        assert url == 'https://graphite.ubunet.canonical.com/openid/+login', url
        assert br.title() == 'OpenID Authentication Required', br.title()

        br.select_form(nr=0)
        br.submit()
        url = br.geturl()
        assert url == 'https://graphite.ubunet.canonical.com/openid/+login', url
        assert br.title() == 'OpenID Authentication Required', br.title()

        br.select_form(nr=0)
        br.submit()
        if not br.title().startswith("Authenticate to "):
            url = br.geturl()
            assert url.startswith('https://login.ubuntu.com/'), url
            assert url.endswith('/+decide'), url
            assert br.title() == 'Log in', br.title()

            br.select_form(nr=0)
            br.form['email'] = raw_input         ("Email address: ")
            br.form['password'] = getpass.getpass("     Password: ")
            br.submit()
        if not br.title().startswith("Authenticate to "):
            response = br.response().read()
            assert 'To continue use 2 factor authentication' in response
            twofer = raw_input("2-factor auth: ")
            br.select_form(nr=0)
            br.form['oath_token'] = twofer
            br.submit()
        url = br.geturl()
        assert url.startswith('https://login.ubuntu.com/'), url
        assert url.endswith('/+decide'), url
        assert br.title().startswith("Authenticate to "), br.title()

        br.select_form(nr=0)
        br.submit()

        # assert br.geturl() == url, br.geturl()
        # content_type = br.response().info()['Content-Type']
        # assert content_type == 'text/plain', content_type

fetch = Fetcher().fetch

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print "Usage:  %s url cookie_file" % sys.argv[0]
        sys.exit(1)
    print fetch(sys.argv[1], sys.argv[2]).read()
